<template>
  <div v-if="getErrorData.isNeedReload">
    <div class="h-screen flex items-center justify-center">
      <AppCircularLoading />
    </div>
  </div>
  <div
    v-if="!getErrorData.isNeedReload"
    class="font-sans antialiased bg-white dark:bg-black text-black dark:text-white grid min-h-screen place-content-center overflow-hidden"
  >
    <div class="fixed left-0 right-0 spotlight z-10"></div>
    <div class="max-w-520px text-center z-20">
      <h1 class="text-8xl sm:text-10xl font-medium mb-8">
        {{ error?.statusCode }}
      </h1>
      <p
        class="text-xl px-8 sm:px-0 sm:text-4xl font-light mb-16 leading-tight"
      >
        {{ error?.message }}
      </p>
      <div class="w-full flex items-center justify-center">
        <a
          href="/"
          class="gradient-border text-md sm:text-xl py-2 px-4 sm:py-3 sm:px-6 cursor-pointer"
          >Go back home</a
        >
      </div>
    </div>
  </div>
  <div v-else></div>
</template>

<script setup lang="ts">
import type { NuxtError } from "#app";
import AppCircularLoading from "./components/app-circular-loading.vue";

const props = defineProps({
  error: Object as () => NuxtError,
});

const getErrorData = computed<Record<string, any>>(() => {
  if (!props.error?.data) return {};
  return JSON.parse(props.error.data);
});

if (getErrorData.value.isNeedReload) {
  navigateTo("/");
}
</script>

<style scoped>
.spotlight {
  background: linear-gradient(45deg, #00dc82, #36e4da 50%, #0047e1);
  bottom: -30vh;
  filter: blur(20vh);
  height: 40vh;
}

.gradient-border {
  -webkit-backdrop-filter: blur(10px);
  backdrop-filter: blur(10px);
  border-radius: 0.5rem;
  position: relative;
}

@media (prefers-color-scheme: light) {
  .gradient-border {
    background-color: #ffffff4d;
  }

  .gradient-border:before {
    background: linear-gradient(
      90deg,
      #e2e2e2,
      #e2e2e2 25%,
      #00dc82 50%,
      #36e4da 75%,
      #0047e1
    );
  }
}

@media (prefers-color-scheme: dark) {
  .gradient-border {
    background-color: #1414144d;
  }

  .gradient-border:before {
    background: linear-gradient(
      90deg,
      #303030,
      #303030 25%,
      #00dc82 50%,
      #36e4da 75%,
      #0047e1
    );
  }
}

.gradient-border:before {
  background-size: 400% auto;
  border-radius: 0.5rem;
  bottom: 0;
  content: "";
  left: 0;
  -webkit-mask: linear-gradient(#fff 0 0) content-box, linear-gradient(#fff 0 0);
  mask: linear-gradient(#fff 0 0) content-box, linear-gradient(#fff 0 0);
  -webkit-mask-composite: xor;
  mask-composite: exclude;
  opacity: 0.5;
  padding: 2px;
  position: absolute;
  right: 0;
  top: 0;
  transition: background-position 0.3s ease-in-out, opacity 0.2s ease-in-out;
  width: 100%;
}

.gradient-border:hover:before {
  background-position: -50% 0;
  opacity: 1;
}

.bg-white {
  --tw-bg-opacity: 1;
  background-color: #fff;
  background-color: rgba(255, 255, 255, var(--tw-bg-opacity));
}

.cursor-pointer {
  cursor: pointer;
}

.flex {
  display: flex;
}

.grid {
  display: grid;
}

.place-content-center {
  place-content: center;
}

.items-center {
  align-items: center;
}

.justify-center {
  justify-content: center;
}

.font-sans {
  font-family: ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont,
    Segoe UI, Roboto, Helvetica Neue, Arial, Noto Sans, sans-serif,
    Apple Color Emoji, Segoe UI Emoji, Segoe UI Symbol, Noto Color Emoji;
}

.font-medium {
  font-weight: 500;
}

.font-light {
  font-weight: 300;
}

.text-8xl {
  font-size: 6rem;
  line-height: 1;
}

.text-xl {
  font-size: 1.25rem;
  line-height: 1.75rem;
}

.leading-tight {
  line-height: 1.25;
}

.mb-8 {
  margin-bottom: 2rem;
}

.mb-16 {
  margin-bottom: 4rem;
}

.max-w-520px {
  max-width: 520px;
}

.min-h-screen {
  min-height: 100vh;
}

.overflow-hidden {
  overflow: hidden;
}

.px-8 {
  padding-left: 2rem;
  padding-right: 2rem;
}

.py-2 {
  padding-bottom: 0.5rem;
  padding-top: 0.5rem;
}

.px-4 {
  padding-left: 1rem;
  padding-right: 1rem;
}

.fixed {
  position: fixed;
}

.left-0 {
  left: 0;
}

.right-0 {
  right: 0;
}

.text-center {
  text-align: center;
}

.text-black {
  --tw-text-opacity: 1;
  color: #000;
  color: rgba(0, 0, 0, var(--tw-text-opacity));
}

.antialiased {
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.w-full {
  width: 100%;
}

.z-10 {
  z-index: 10;
}

.z-20 {
  z-index: 20;
}

@media (min-width: 640px) {
  .sm\:text-4xl {
    font-size: 2.25rem;
    line-height: 2.5rem;
  }

  .sm\:text-xl {
    font-size: 1.25rem;
    line-height: 1.75rem;
  }

  .sm\:text-10xl {
    font-size: 10rem;
    line-height: 1;
  }

  .sm\:px-0 {
    padding-left: 0;
    padding-right: 0;
  }

  .sm\:py-3 {
    padding-bottom: 0.75rem;
    padding-top: 0.75rem;
  }

  .sm\:px-6 {
    padding-left: 1.5rem;
    padding-right: 1.5rem;
  }
}

@media (prefers-color-scheme: dark) {
  .dark\:bg-black {
    --tw-bg-opacity: 1;
    background-color: #000;
    background-color: rgba(0, 0, 0, var(--tw-bg-opacity));
  }

  .dark\:text-white {
    --tw-text-opacity: 1;
    color: #fff;
    color: rgba(255, 255, 255, var(--tw-text-opacity));
  }
}
</style>
